Ext.define('App.utility.Date', {
    singleton: true,

    TODAY: 1,
    YESTERDAY: 2,
    WEEK: 3,
    LAST_2_DAYS: 4,
    LAST_7_DAYS: 5,
    PREV_WEEK: 6,
    LAST_2_WEEKS: 7,
    MONTH: 8,
    LAST_30_DAYS: 9,
    PREV_MONTH: 10,
    LAST_60_DAYS: 11,
    LAST_3_MONTH: 12,
    LAST_6_MONTH: 13,
    LAST_12_MONTH: 14,
    YEAR: 15,
    PREV_YEAR: 16,
    CUSTOM: 99,

    /*Private*/
    _getCurrentServerDate: function() {
        return get_current_time();
    },

    /*Public*/
    getToday: function() {
        var time = this._getCurrentServerDate();
        var date = Ext.Date.parse(time, "U");
        return Ext.Date.format(date, "Y-m-d");
    },

    getYesterday: function() {
        var time = this._getCurrentServerDate();
        time = time - 60 * 60 * 24;
        var date = Ext.Date.parse(time, "U");
        return Ext.Date.format(date, "Y-m-d");
    },

    getThisWeek: function() {
        var time = this._getCurrentServerDate();
        var date = Ext.Date.parse(time, "U");
        var numberDayInWeek =  Ext.Date.format(date, "w");

        time = time - 60 * 60 * 24 * (numberDayInWeek - 1);
        date = Ext.Date.parse(time, "U");
        return Ext.Date.format(date, "Y-m-d");
    },

    getLastNDays: function(days) {
        var time = this._getCurrentServerDate();
            time = time - 60 * 60 * 24 * days;
        var date = Ext.Date.parse(time, "U");
        return Ext.Date.format(date, "Y-m-d");
    },

    getPrevWeek: function() {
        var time = this._getCurrentServerDate();
        var date = Ext.Date.parse(time, "U");
        var numberDayInWeek =  Ext.Date.format(date, "w");
        time = time - 60 * 60 * 24 * (numberDayInWeek - 0 + 6);
        date = Ext.Date.parse(time, "U");
        return Ext.Date.format(date, "Y-m-d");
    },

    getThisMonth: function() {
        var time = this._getCurrentServerDate();
        var date = Ext.Date.parse(time, "U");
        return Ext.Date.format(date, "Y-m-01");
    },

    getPrevNMonth: function(monthsCount) {
        var time = this._getCurrentServerDate();
        var date = Ext.Date.parse(time, "U");
        var toDate = Ext.Date.parse(Ext.Date.format(date, "Y-m-01 00:00:00"), "Y-m-d H:i:s");
        var fromDate = Ext.Date.add(toDate, Ext.Date.MONTH, (-1 * monthsCount));
        return Ext.Date.format(fromDate, "Y-m-01");
    },

    getThisYear: function() {
        var time = this._getCurrentServerDate();
        var date = Ext.Date.parse(time, "U");
        return Ext.Date.format(date, "Y-01-01");
    },

    getPrevNYears: function(yearsCount) {
        var time = this._getCurrentServerDate();
        var date = Ext.Date.parse(time, "U");
        var toDate = Ext.Date.parse(Ext.Date.format(date, "Y-01-01 00:00:00"), "Y-m-d H:i:s");
        var fromDate = Ext.Date.add(toDate, Ext.Date.YEAR, (-1 * yearsCount));
        return Ext.Date.format(fromDate, "Y-01-01");
    }
});
