Ext.define('App.view.Navigation', {
    extend: 'Ext.Container',
    alias : 'widget.navigation',
    layout: {
        type: 'hbox',
        align: 'stretch'
    },
    height: 70,
    items: [
        {
            xtype: 'container',
            style: "background: url('misc/images/navigation-logo.png') 15px 5px no-repeat; height: 70px; width: 400px;",
            html: '&nbsp;'
        },
        {
            xtype: 'container',
            flex: 1,
            layout: {
                type: 'vbox',
                align: 'stretch'
            },
            padding: '0 15px 0 0',
            items: [
                {
                    xtype: 'container',
                    layout: 'hbox',
                    height: 40,
                    padding: '10px 0 0 0',
                    items: [
                        {
                            xtype: 'container',
                            flex: 1
                        },
                        {
                            xtype: 'container',
                            itemId: 'navigationUserName',
                            cls: 'w-navigation-name',
                            html: User.name
                        },
                        {
                            xtype: 'container',
                            cls: 'w-navigation-updatedb',
                            items: [
                                {
                                    xtype: 'container',
                                    itemId: 'navigationUserUpdatedb',
                                    autoEl: {
                                        tag: 'a',
                                        html: _t('Update')
                                    }
                                }
                            ]
                        },
                        {
                            xtype: 'container',
                            cls: 'w-navigation-settings',
                            items: [
                                {
                                    xtype: 'container',
                                    itemId: 'navigationUserSettings',
                                    autoEl: {
                                        tag: 'a',
                                        html: _t('Settings')
                                    }
                                }
                            ]
                        }
                    ]
                },
                {
                    xtype: 'container',
                    layout: 'hbox',
                    height: 30,
                    hidden: isRemoteMode(),
                    items: [
                        {
                            xtype: 'container',
                            flex: 1
                        },
                        {
                            xtype: 'container',
                            itemId: 'navigationProgressLeftDate',
                            cls: 'w-navigation-progress-date',
                            html: ''
                        },
                        {
                            xtype: 'navigationInformer'
                        },
                        {
                            xtype: 'container',
                            itemId: 'navigationProgressRightDate',
                            cls: 'w-navigation-progress-date',
                            html: ''
                        }
                    ]
                }
            ]
        }
    ]
});
