Ext.define('App.view.Viewport', {
    extend: 'Ext.container.Viewport',
    layout: 'anchor',
    style: "background: url('misc/images/navigation-bg.jpg?2') top repeat-x;",
    items: [
        {
            xtype: 'navigation',
            style: 'margin: 0px auto;',
            minWidth: 1240,
            maxWidth: 1536
        },
        {
            xtype: 'container',
            itemId: 'viewport',
            anchor: '100% -70',
            padding: '15px 20px 15px 20px',
            style: 'margin: 0px auto;',
            minWidth: 1240,
            maxWidth: 1536,
            layout: {                        
                type: 'vbox',
                align: 'stretch'
            },
            items: [
                {
                    xtype: 'reports'
                },
                {
                    xtype: 'filter'
                },
                {
                    xtype: 'container',
                    itemId: 'viewerToolbarHolder',
                    layout: 'fit',
                    padding: '15 0 0 0',
                    items: [
                        {
                            xtype: 'container',
                            itemId: 'viewerToolbar',
                            layout: 'column',
                            style: 'overflow: hidden;',
                            items: [
                                {
                                    xtype: 'container',
                                    columnWidth: 1,
                                    layout: 'column',
                                    items: [
                                        {
                                            xtype: 'viewportSwitcher',
                                            itemId: 'viewerTypeSwitcher',
                                            menu: [
                                                {
                                                    id: 'TABLE',
                                                    text: _t('Data grid'),
                                                    active: 1
                                                },
                                                {
                                                    id: 'CHART_LINE',
                                                    text: _t('Line Chart'),
                                                    active: 0
                                                },
                                                {
                                                    id: 'CHART_AREA',
                                                    text: _t('Area Chart'),
                                                    active: 0
                                                },
                                                {
                                                    id: 'CHART_PIE',
                                                    text: _t('Pie Chart'),
                                                    active: 0
                                                },
                                                {
                                                    id: 'CHART_BAR',
                                                    text: _t('Bar Chart'),
                                                    active: 0
                                                },
                                                {
                                                    id: 'CHART_COLUMN',
                                                    text: _t('Column Chart'),
                                                    active: 0
                                                }
                                            ]
                                        },
                                        {
                                            xtype: 'viewportSwitcher',
                                            itemId: 'viewerChartLabelSwitcher',
                                            margin: '0 0 0 10',
                                            switchable: true,
                                            menu: [
                                                {
                                                    id: 'CHART_LABELS',
                                                    text: _t('Chart Labels'),
                                                    active: 0
                                                }
                                            ]
                                        }
                                    ]
                                },
                                {
                                    xtype: 'container',
                                    itemId: 'viewerColumnsContainer',
                                    layout: 'column',
                                    items: [
                                        {
                                            xtype: 'viewerGrouping'
                                        },
                                        {
                                            xtype: 'viewerMetric'
                                        },
                                        {
                                            xtype: 'viewerFullPage'
                                        }
                                    ]
                                }
                            ]
                        }
                    ]
                },
                {
                    xtype: 'container',
                    itemId: 'viewerHolder',
                    layout: 'fit',
                    flex: 1,
                    padding: '10 0 0 0',
                    items: [
                        {
                            xtype: 'viewer'
                        }
                    ]
                }
            ]
        }
        
    ]
});