Ext.define('App.view.bootstrap.Notification', {
    extend: 'Ext.Container',
    cls: 'w-boot-dialog',
    floating: true,
    width: 400,
    initComponent: function() {
        this.renderTo = Ext.getBody();
        Ext.getBody().query('.w-boot-dialog').forEach(function(el){
            if (el && el.id && Ext.ComponentManager.get(el.id)){
                Ext.ComponentManager.get(el.id).destroy();
            }
        });
        this.renderTpl = [
            '<div class="w-boot-dialog-tt"><div class="w-boot-dialog-tl"><div class="w-boot-dialog-tr"></div></div></div>',
            '<div class="w-boot-dialog-cl"><div class="w-boot-dialog-cr"><div class="w-boot-dialog-cc">',
                '<div class="w-boot-title">{title}</div>',
                '<div class="w-boot-contents"></div>',
            '</div></div></div>',
            '<div class="w-boot-dialog-bb"><div class="w-boot-dialog-bl"><div class="w-boot-dialog-br"></div></div></div>'
        ];
        this.renderSelectors = {
            titleEl: 'div.w-boot-title',
            formEl: 'div.w-boot-contents'
        }
        this.renderData = {
            title: this.title
        }
        
        this.callParent(arguments);
    },
    afterRender: function() {
        this.callParent(arguments);
        this.show();
    },
    destroy: function() {
        Ext.EventManager.removeResizeListener(this.align, this);
        this.callParent(arguments);
    },
    show: function() {
        Ext.EventManager.onWindowResize(this.align, this);
        
        this.align();
        this.callParent(arguments);
    },
    hide: function() {
        Ext.EventManager.removeResizeListener(this.align, this);
        
        this.callParent(arguments);
    },
    align: function() {
        var width = Ext.getBody().getWidth();
        var height = Ext.getBody().getHeight();
        var left = parseInt(width / 2) - parseInt(this.getWidth() / 2);
        var top = parseInt(height / 2) - parseInt(this.getHeight() / 2) - parseInt(height * 0.1);
        
        this.setPosition( left, top, false);
    }
});