Ext.define('App.view.filter.DestinationEditor', {
    extend: 'App.view.filter.Editor',
    width: 900,
    onRenderContent: function(state) {
        // Rendering Internal to External elements
        this.intToExtCheckBox = Ext.create('Ext.form.field.Checkbox', {
            style: 'padding: 2px 0 0 0; margin: 0px; line-height: 0px;',
            checked: state['intToExtEnabled']
        } );
        
        this.intToExtFromField = Ext.create('App.view.filter.field.DestinationInt', {
            fieldLabel: _t('From'),
            emptyText: _t('Any'),
            labelAlign: 'left',
            labelWidth: 50,
            margin: '0 10 0 5',
            columnWidth: 0.5,
            arrayValue: state['intToExtFrom'],
            disabled: state['intToExtEnabled'] ? false : true
        } );
        
        this.intToExtToField = Ext.create('App.view.filter.field.DestinationExt', {
            fieldLabel: _t('To'),
            emptyText: _t('Any'),
            labelAlign: 'left',
            labelWidth: 50,
            margin: '0 5 0 10',
            columnWidth: 0.5,
            arrayValue: state['intToExtTo'],
            disabled: state['intToExtEnabled'] ? false : true
        } );
       
        this.intToExtCnt = Ext.create('Ext.container.Container', {
            layout: 'column',
            renderTo: this.formEl,
            items: [
                this.intToExtCheckBox,
                {
                    xtype: 'container',
                    style: 'white-space: nowrap; padding: 3px 0 0 10px; font-weight: 700; color:#333;',
                    width: 150,
                    html: _t('Internal to External')
                },
                {
                    xtype: 'container',
                    margin: '0 0 0 10',
                    layout: 'column',
                    columnWidth: 1,
                    items: [
                        this.intToExtFromField,
                        this.intToExtToField
                    ],
                    listeners: {
                        'pickerShow': this.onPickerShow,
                        'pickerHide': this.onPickerHide,
                        scope: this
                    }
                }
            ]
        } );
        
        // Rendering External to Internal elements
        this.extToIntCheckBox = Ext.create('Ext.form.field.Checkbox', {
            style: 'padding: 2px 0 0 0; margin: 0px; line-height: 0px;',
            checked: state['extToIntEnabled']
        } );
        this.extToIntFromField = Ext.create('App.view.filter.field.DestinationExt', {
            fieldLabel: _t('From'),
            emptyText: _t('Any'),
            labelAlign: 'left',
            labelWidth: 50,
            margin: '0 10 0 5',
            columnWidth: 0.5,
            arrayValue: state['extToIntFrom'],
            disabled: state['extToIntEnabled'] ? false : true
        } );
        this.extToIntToField = Ext.create('App.view.filter.field.DestinationInt', {
            fieldLabel: _t('To'),
            emptyText: _t('Any'),
            labelAlign: 'left',
            labelWidth: 50,
            margin: '0 5 0 10',
            columnWidth: 0.5,
            arrayValue: state['extToIntTo'],
            disabled: state['extToIntEnabled'] ? false : true
        } );
       
        this.extToIntCnt = Ext.create('Ext.container.Container', {
            layout: 'column',
            renderTo: this.formEl,
            padding: '10 0 0 0',
            items: [
                this.extToIntCheckBox,
                {
                    xtype: 'container',
                    style: 'white-space: nowrap; padding: 3px 0 0 10px; font-weight: 700; color:#333;',
                    width: 150,
                    html: _t('External to Internal')
                },
                {
                    xtype: 'container',
                    margin: '0 0 0 10',
                    layout: 'column',
                    columnWidth: 1,
                    items: [
                        this.extToIntFromField,
                        this.extToIntToField
                    ],
                    listeners: {
                        'pickerShow': this.onPickerShow,
                        'pickerHide': this.onPickerHide,
                         scope: this
                    }
                }
            ]
        } );
        
        // Rendering Internal to Internal elements
        this.intToIntCheckBox = Ext.create('Ext.form.field.Checkbox', {
            style: 'padding: 2px 0 0 0; margin: 0px; line-height: 0px;',
            checked: state['intToIntEnabled']
        } );
        
        this.intToIntFromField = Ext.create('App.view.filter.field.DestinationInt', {
            fieldLabel: _t('From'),
            emptyText: _t('Any'),
            labelAlign: 'left',
            labelWidth: 50,
            margin: '0 10 0 5',
            columnWidth: 0.5,
            arrayValue: state['intToIntFrom'],
            disabled: state['intToIntEnabled'] ? false : true
        } );
        
        this.intToIntToField = Ext.create('App.view.filter.field.DestinationInt', {
            fieldLabel: _t('To'),
            emptyText: _t('Any'),
            labelAlign: 'left',
            labelWidth: 50,
            margin: '0 5 0 10',
            columnWidth: 0.5,
            arrayValue: state['intToIntTo'],
            disabled: state['intToIntEnabled'] ? false : true
        } );
       
        this.intToIntCnt = Ext.create('Ext.container.Container', {
            layout: 'column',
            renderTo: this.formEl,
            padding: '10 0 0 0',
            items: [
                this.intToIntCheckBox,
                {
                    xtype: 'container',
                    style: 'white-space: nowrap; padding: 3px 0 0 10px; font-weight: 700; color:#333;',
                    width: 150,
                    html: _t('Internal to Internal')
                },
                {
                    xtype: 'container',
                    margin: '0 0 0 10',
                    layout: 'column',
                    columnWidth: 1,
                    items: [
                        this.intToIntFromField,
                        this.intToIntToField
                    ],
                    listeners: {
                        'pickerShow': this.onPickerShow,
                        'pickerHide': this.onPickerHide,
                        scope: this
                    }
                }
            ]
        } );

        this.intToExtCheckBox.addListener('change', this.intToExtCheckBoxChange, this);
        this.intToExtFromField.addListener('change', this.onIntToExtFromFieldChange, this);
        this.intToExtToField.addListener('change', this.onIntToExtToFieldChange, this);
        
        this.extToIntFromField.addListener('change', this.onExtToIntFromFieldChange, this);
        this.extToIntToField.addListener('change', this.onExtToIntToFieldChange, this);
        this.extToIntCheckBox.addListener('change', this.onExtToIntChangeChange, this);
        
        this.intToIntFromField.addListener('change', this.onIntToIntFromFieldChange, this);
        this.intToIntToField.addListener('change', this.onIntToIntToFieldChange, this);
        this.intToIntCheckBox.addListener('change', this.onIntToIntChangeChange, this);

        this.callParent(arguments);
    },
    onPickerShow: function(picker) {
        // TODO Uncomment this if need.
//        if(this.activePicker != undefined) {
//            this.activePicker.hidePicker();
//        }
        this.activePicker = picker;
    },
    onPickerHide: function(picker){
        if(this.activePicker != undefined && this.activePicker == picker) {
            this.activePicker = undefined;
        }
    },
    intToExtCheckBoxChange: function(field, value) {
        if (this.ignoreStateEvents) {
            return;
        }
        
        if( !value ) {
            this.intToExtFromField.setDisabled(true);
            this.intToExtToField.setDisabled(true);
        } else {
            this.intToExtFromField.setDisabled(false);
            this.intToExtToField.setDisabled(false);
        }
        
        this.state['intToExtEnabled'] = value;
        this.fireEvent('change', this.state);
    },
    onExtToIntChangeChange: function(field, value) {
        if (this.ignoreStateEvents) {
            return;
        }
        
        if( !value ) {
            this.extToIntFromField.setDisabled(true);
            this.extToIntToField.setDisabled(true);
        } else {
            this.extToIntFromField.setDisabled(false);
            this.extToIntToField.setDisabled(false);
        }
        
        this.state['extToIntEnabled'] = value;
        this.fireEvent('change', this.state);
    },
    onIntToIntChangeChange: function(field, value) {
        if (this.ignoreStateEvents) {
            return;
        }
        
        if( !value ) {
            this.intToIntFromField.setDisabled(true);
            this.intToIntToField.setDisabled(true);
        } else {
            this.intToIntFromField.setDisabled(false);
            this.intToIntToField.setDisabled(false);
        }   
        
        this.state['intToIntEnabled'] = value;
        this.fireEvent('change', this.state);
    },
    onIntToExtFromFieldChange: function(field) {
        if (this.ignoreStateEvents) {
            return;
        }
        
        this.state['intToExtFrom'] = field.getArrayValue();
        this.fireEvent('change', this.state);
    },
    onIntToExtToFieldChange: function(field) {
        if (this.ignoreStateEvents) {
            return;
        }
        
        this.state['intToExtTo'] = field.getArrayValue();
        this.fireEvent('change', this.state);
    },
    onExtToIntFromFieldChange: function(field) {
        if (this.ignoreStateEvents) {
            return;
        }
        
        this.state['extToIntFrom'] = field.getArrayValue();
        this.fireEvent('change', this.state);
    },
    onExtToIntToFieldChange: function(field) {
        if (this.ignoreStateEvents) {
            return;
        }
        
        this.state['extToIntTo'] = field.getArrayValue();
        this.fireEvent('change', this.state);
    },
    onIntToIntFromFieldChange: function(field) {
        if (this.ignoreStateEvents) {
            return;
        }
        
        this.state['intToIntFrom'] = field.getArrayValue();
        this.fireEvent('change', this.state);
    },
    onIntToIntToFieldChange: function(field) {
        if (this.ignoreStateEvents) {
            return;
        }
        
        this.state['intToIntTo'] = field.getArrayValue();
        this.fireEvent('change', this.state);
    },
    hide: function(){
        if(this.activePicker != undefined) {
            this.activePicker.hidePicker();
            return;
        } else {
            this.callParent();
        }
    },
    setState: function(s) {
        this.state = s;
        this.conditionEl.update(this.getDescription(s));
        
        if (!this.contentRendered) {
            return;
        }
        
        this.ignoreStateEvents = true;
        
        // Int to Ext
        this.intToExtCheckBox.setValue(s['intToExtEnabled']);
        
        if( s['intToExtEnabled'] ) {
            this.intToExtFromField.setDisabled(false);
            this.intToExtToField.setDisabled(false);
        } else {
            this.intToExtFromField.setDisabled(true);
            this.intToExtToField.setDisabled(true);
        }
        
        this.intToExtFromField.setArrayValue(s['intToExtFrom']);
        this.intToExtToField.setArrayValue(s['intToExtTo']);
        
        // Ext to Int
        this.extToIntCheckBox.setValue(s['extToIntEnabled']);
        
        if( s['extToIntEnabled'] ) {
            this.extToIntFromField.setDisabled(false);
            this.extToIntToField.setDisabled(false);
        } else {
            this.extToIntFromField.setDisabled(true);
            this.extToIntToField.setDisabled(true);
        }
        
        this.extToIntFromField.setArrayValue(s['extToIntFrom']);
        this.extToIntToField.setArrayValue(s['extToIntTo']);
        
        // Int to Int
        this.intToIntCheckBox.setValue(s['intToIntEnabled']);
        
        if( s['intToIntEnabled'] ) {
            this.intToIntFromField.setDisabled(false);
            this.intToIntToField.setDisabled(false);
        } else {
            this.intToIntFromField.setDisabled(true);
            this.intToIntToField.setDisabled(true);
        }
        
        this.intToIntFromField.setArrayValue(s['intToIntFrom']);
        this.intToIntToField.setArrayValue(s['intToIntTo']);
        
        this.ignoreStateEvents = false;
    },
    getDefaultState: function() {
        var s = {
            'intToExtEnabled': false,
            'intToExtFrom': new Array(),
            'intToExtTo': new Array(),
            'extToIntEnabled': false,
            'extToIntFrom': new Array(),
            'extToIntTo': new Array(),
            'intToIntEnabled': false,
            'intToIntFrom': new Array(),
            'intToIntTo': new Array()
        }
        
        return s;
    },
    getDescription: function(state) {
        var desc = this.getDestinationsDescription(state);
        
        if (desc) {
            return sprintf('%(description)s', { description : desc });
        }
        
        return this.getAnyDescription();
    },
    getFieldDescription: function(state) {
        var desc = this.getDestinationsDescription(state);
        
        if (desc) {
            return sprintf('%(description)s', { description : desc });
        }
        
        return this.getAnyFieldDescription();
    },
    
    getFilterDescription: function() {
        var desc = this.getDestinationsDescription(this.state);
        
        if (desc) {
            return _t('Direction')+': '+desc;
        }
        
        return null;
    },
    
    getDestinationsDescription: function(state) {
        var s = state, r = new Array(), rf, rt, rs;
        
        if( s['intToExtEnabled'] && s['intToExtFrom'].length == 0 &&  s['intToExtTo'].length == 0 &&
            s['extToIntEnabled'] && s['extToIntFrom'].length == 0 &&  s['extToIntTo'].length == 0 &&
            s['intToIntEnabled'] && s['intToIntFrom'].length == 0 &&  s['intToIntTo'].length == 0 ) {
            return undefined;
        }
        
        if( s['intToExtEnabled'] ) {
            rs = undefined;
            rf = this.getDestinationDescription(s['intToExtFrom']);
            rt = this.getDestinationDescription(s['intToExtTo']);
            
            if( rf && rt ) {
                rs = sprintf(_t('From_%(from)s_to_%(to)s'), { from : rf, to : rt });
            } else if ( rf ) {
                rs = sprintf(_t('From_%(from)s_to_%(to)s'), { from : rf, to: _t('Any')+' '+_t('External number') });
            } else if ( rt ) {
                rs = sprintf(_t('From_%(from)s_to_%(to)s'), { from : _t('Any')+' '+_t('Internal number'), to: rt });
            } else {
                rs = sprintf(_t('From_%(from)s_to_%(to)s'), { from : _t('Any')+' '+_t('Internal number'), to: _t('Any')+' '+_t('External number') });
            }
            
            if( rs ) {
                r.push(rs);
            }
        }
        
        if( s['extToIntEnabled'] ) {
            rs = undefined;
            rf = this.getDestinationDescription(s['extToIntFrom']);
            rt = this.getDestinationDescription(s['extToIntTo']);
            
            if( rf && rt ) {
                rs = sprintf(_t('From_%(from)s_to_%(to)s'), { from : rf, to : rt });
            } else if ( rf ) {
                rs = sprintf(_t('From_%(from)s_to_%(to)s'), { from : rf, to: _t('Any')+' '+_t('Internal number') });
            } else if ( rt ) {
                rs = sprintf(_t('From_%(from)s_to_%(to)s'), { from : _t('Any')+' '+_t('External number'), to: rt });
            } else {
                rs = sprintf(_t('From_%(from)s_to_%(to)s'), { from : _t('Any')+' '+_t('External number'), to: _t('Any')+' '+_t('Internal number') });
            }
            
            if( rs ) {
                r.push(rs);
            }
        }
        
        if( s['intToIntEnabled'] ) {
            rs = undefined;
            rf = this.getDestinationDescription(s['intToIntFrom']);
            rt = this.getDestinationDescription(s['intToIntTo']);
            
            if( rf && rt ) {
                rs = sprintf(_t('From_%(from)s_to_%(to)s'), { from : rf, to : rt });
            } else if ( rf ) {
                rs = sprintf(_t('From_%(from)s_to_%(to)s'), { from : rf, to: _t('Any')+' '+_t('Internal number') });
            } else if ( rt ) {
                rs = sprintf(_t('From_%(from)s_to_%(to)s'), { from : _t('Any')+' '+_t('Internal number'), to: rt });
            } else {
                rs = sprintf(_t('From_%(from)s_to_%(to)s'), { from : _t('Any'), to: _t('Any')+' '+_t('Internal number') });
            }
            
            if( rs ) {
                r.push(rs);
            }
        }
        
        return r.join(_t(' and '));
    },
    getDestinationDescription: function(users) {
        var i, result = new Array();
        
        if( users.length == 0 ) {
            return undefined;
        }
        
        for( i=0; i < users.length; i++ ) {
            result.push(users[i]['name']);
        }
        
        if ( result.length > 0 ) {
            return result.join(', ');
        } else {
            return undefined;
        }
    }
} );
