Ext.define('App.view.filter.Field', {
    extend: 'Ext.form.field.Display',
    cls: 'filter-field',
    value: _t('Any'),
    initComponent: function() {
        this.callParent(arguments);
    },
    afterRender: function() {
        this.callParent(arguments);
        this.getEditor().on('afterhide', this.onEditorHide, this)
        this.getEditor().on('change', this.onEditorChange, this)
        this.getEl().on('click', this.onClick, this);
    },
    disableField: function() {
        var el = this.getEl().down('div.x-form-item-body');
        el.mask();
    },
    enableField: function() {
        var el = this.getEl().down('div.x-form-item-body');
        el.unmask();
    },
    onClick: function(event, el) {
        el = Ext.get(el);
        
        if (el.hasCls('x-form-item-body') || el.hasCls('x-form-display-field')) {
            if (!this.disabled) {
                this.editor.focus();
            }
        }
    },
    onEditorHide: function() {
        var state = this.editor.getState();
        var desc = this.editor.getFieldDescription(state);
        
        this.setValue(desc);
    },
    onEditorChange: function() {
        var state = this.editor.getState();
        var desc = this.editor.getFieldDescription(state);

        this.setValue(desc);
    },
    setState: function(state) {
        this.editor.setState(state);
        this.setValue(this.editor.getFieldDescription(state));
    },
    getState: function() {
        return this.editor.getState();
    },
    getDefaultState: function() {
        return this.editor.getDefaultState();
    },
    getEditor: function() {
        return this.editor;
    },
    getFilterDescription: function() {
        return this.editor.getFilterDescription();
    }
} );