Ext.define('App.view.filter.Observer', {
	singleton: true,
    editors: new Array(),
    focused: false,
    focusedEditor: false,
    focusedField: false,
    constructor: function() {
        this.callParent(arguments);
        Ext.getBody().addListener( 'click', this.onClick, this );
    },
    focus: function(editor) {
        for( var i=0; i < this.editors.length; i++ ) {
            if( this.editors[i].getId() != editor.getId() && this.editors[i].isVisible() ) {
                this.editors[i].hide();
            }
        }
        
        this.focused = true;
        this.focusedEditor = editor;
        this.focusedField = editor.getTarget();
    },
    push: function(editor) {
        this.editors.push(editor);
    },
    onClick: function( event, element ) {
        if( !this.focused ) {
            return false;
        }
        
        var target = Ext.get(element);
        var parent = false;
        var prevent = false;
        var index;
        
        while(true) {
            if( !parent ) {
                // parent not available
                if( target.id == this.focusedEditor.getId() || target.id == this.focusedField.getId() ) {
                    prevent = true;
                    break;
                }
                if( target.id == Ext.getBody().id ) {
                    break;
                }
                
                index = parseInt(target.getStyle('z-index'));
                
                if( index > 1 ) {
                    prevent = true;
                    break;
                }
                
                parent = target.parent();
            } else {
                // parent available
                if( parent.id == this.focusedEditor.getId() || parent.id == this.focusedField.getId() ) {
                    prevent = true;
                    break;
                }
                
                if( parent.id == Ext.getBody().id ) {
                    break;
                }
                
                index = parseInt(parent.getStyle('z-index'));
                
                if( index > 1 ) {
                    prevent = true;
                    break;
                }
                
                parent = parent.parent();
            }
        }
        
        if( !prevent || (target && target.hasCls('x-form-item-label'))) {
            this.focused = false;
            this.focusedEditor.hide();
            this.focusedEditor = false;
            this.focusedField = false;
        }
    }
} );