Ext.define('App.view.filter.field.combo.Search', {
    extend: 'Ext.container.Container',
    cls: 'w-dst-picker-search',
    anchor: '100%',
    layout: 'fit',
    padding: 3,
    initComponent: function() {
        var self = this;
                
        this.triggerField = Ext.create('Ext.form.field.Trigger', {
            xtype: 'trigger',
            anchor: '100%',
            cls: 'w-dst-picker-search-trigger',
            emptyText: '',
            enableKeyEvents: true,
            trigger1Cls: Ext.baseCSSPrefix + 'form-clear-trigger',
            trigger2Cls: Ext.baseCSSPrefix + 'form-search-trigger',
            onTrigger1Click: function() {
                self.onTriggerCreateClick.call(self, arguments);
            },
            onTrigger2Click: function() {
                self.onTriggerSearchClick.call(self, arguments);
            }
        });
        this.triggerField.on('specialkey', this.onTriggerFieldSpecialKey, this);
        this.triggerField.on('keyup', this.onTriggerFieldKeyUp, this);

        this.addEvents('search');
        
        this.items = [
            this.triggerField
        ]
        
        this.callParent(arguments);
    },
    getTriggerField: function() {
        return this.triggerField;
    },
    onTriggerCreateClick: function() {
        var number = this.triggerField.getValue();
        var valide_num = /^([\d%#*A-Za-z]{1,22})$|^\+([\d%#*A-Za-z]{1,13})$/;
        
        if (!number || number=='') {
            return;
        } else if (!(number.match(valide_num))) {
            this.triggerField.markInvalid(_t('Phone number that you entered is invalid!'));
            return;
        }
        
        this.selectedStore.add(this.createDestination(number));
        this.triggerField.setValue(null);
    },
    onTriggerSearchClick: function() {
        var number = this.triggerField.getValue();
        this.fireEvent('search', number);
    },
    onTriggerFieldSpecialKey: function(field, e) {
        if (e.getKey() == e.ENTER) {
            var number = this.triggerField.getValue();
            this.fireEvent('search', number);
        }
    },
    onTriggerFieldKeyUp: function(field, e) {
        var self = this;
        var number = this.triggerField.getValue();
        var callback = function() {
            if (self.triggerField.getValue() == number) {
                self.fireEvent('search', number);
            }
        }

        setTimeout(callback, 500);
    },
    createDestination: function(number) {
        var chars = "0123456789ABCDEFGHIJKLMNOPQRSTUVWXTZabcdefghiklmnopqrstuvwxyz";
        var hash = '';
        var i, num;
        for (i=0; i < 8; i++) {
            num = Math.floor(Math.random() * chars.length);
            hash += chars.substring(num,num + 1);
        }
        var id = Date.now() +'-'+ hash;
        var uid = null
        var type = 1;
        var name = number;
        var model = Ext.create('App.model.Destination', {
            id: id,
            uid: uid,
            type: type,
            name: name,
            number: number + '||'
        });
        return model;
    }
} );