Ext.define('App.view.filter.field.combo.list.SelectionModel', {
    extend: 'Ext.selection.CheckboxModel',
    mode: 'SIMPLE',
    enableKeyNav: false,
    constructor: function() {
        this.callParent(arguments);
        
        console.log('this.store', this);
        
        this.fieldSelectedStore.on('remove', this.onFieldSelectedRemove, this);
        this.fieldSelectedStore.on('clear', this.onFieldSelectedClear, this);
    },
    onFieldSelectedRemove: function(store, record, index) {
        console.log('dest selection model', 'onFieldSelectedRemove');
        
        var rec = this.store.getById(record.getId());
        
        if (rec) {
            this.deselect(rec);
        }
    },
    onFieldSelectedClear: function() {
        console.log('dest selection model', 'onFieldSelectedClear');
        
        this.clearSelections();
        this.doSelect(this.getSelection(), false, true);
    },
    onGuaranteedRange: function() {
        console.log('dest selection model', 'onGuaranteedRange');
        
        this.refresh();
    },
    onRowMouseDown: function(view, record, item, index, e) {
        console.log('dest selection model', 'onRowMouseDown');
        
        var selected = this.isSelected(record);
        
        this.callParent(arguments);
        
        if (selected) {
            var rec = this.fieldSelectedStore.getById(record.getId());
            
            if (rec) {
                this.fieldSelectedStore.remove(rec);
            }
        } else {
            if (!this.fieldSelectedStore.getById(record.getId())) {
                this.fieldSelectedStore.add(record.copy());
            }
        }
    },
    refresh: function() {
        console.log('dest selection model', 'refresh');
        
        this.clearSelections();
        
        var i, id, rec, count = this.fieldSelectedStore.getCount();
        
        for (i=0; i < count; i++) {
            id = this.fieldSelectedStore.getAt(i).getId();
            rec = this.store.getById(id);
            
            if (rec) {
                this.selected.add(rec);
            }
        }
        
        return this.doSelect(this.getSelection(), false, true);
    }
} );