Ext.define('App.view.reports.Picker', {
    extend: 'Ext.view.View',
    itemId: 'viewerReportPicker',
    hidden: true,
    hideMode: 'display',
    floating: true,
    cls: 'w-reports-picker',
    constructor: function() {
        this.addEvents('expand', 'collapse', 'selectReport', 'deleteReport', 'fetchPersonalReports', 'fetchedPersonalReports', 'fetchSharedReports', 'fetchedSharedReports');
        this.on('fetchedPersonalReports', this.onFetchedPersonalReports, this);
        this.on('fetchedSharedReports', this.onFetchedSharedReports, this)

        this.callParent(arguments);
    },
    initComponent: function() {
        
        this.categories = [
            { id: '1', name: _t('Call list'), active: 0 },
            { id: '2', name: _t('By time'), active: 0 },
            { id: '3', name: _t('By group'), active: 0 },
            { id: '11', name: _t('By trunk'), active: 0 },
            { id: '4', name: _t('External calls'), active: 0 },
            { id: '5', name: _t('Outgoing calls by'), active: 0 },
            { id: '12', name: _t('Incoming calls by'), active: 0 },
            { id: '6', name: _t('Cost by'), active: 0 },
            { id: '7', name: _t('Trunk usage by group'), active: 0 },
//            { id: '8', name: _t('Ranks analysis'), active: 0 },
            { id: '9', name: _t('Shared reports'), active: 0 },
            { id: '10', name: _t('Personal reports'), active: 0 }
        ]
        
        this.reports = [
            { id: '1-1', parentId: '1', name: _t('Today'), state: {"filter":{"destination":{"intToExtEnabled":false,"intToExtFrom":[],"intToExtTo":[],"extToIntEnabled":false,"extToIntFrom":[],"extToIntTo":[],"intToIntEnabled":false,"intToIntFrom":[],"intToIntTo":[]},"cost":{"leftEnabled":false,"leftValue":null,"rightValue":null,"rightEnabled":false},"bill":{"leftEnabled":false,"leftValue":null,"rightValue":null,"rightEnabled":false},"period":{"type":1,"fromDate":null,"fromTime":null,"toDate":null,"toTime":null},"types":{"call":false,"voicemail":false,"fax":false},"trunks":{"trunks":[]},"pbxes":{"pbxes":[]}},"grouping":[],"metric":["COUNT","COST","BILL"],"view":"TABLE","chart":{},"table":{"type":1,"sorters":{"field":"DATE","dest":"ASC"}}} },
            { id: '1-2', parentId: '1', name: _t('This week'), state: {"filter":{"destination":{"intToExtEnabled":false,"intToExtFrom":[],"intToExtTo":[],"extToIntEnabled":false,"extToIntFrom":[],"extToIntTo":[],"intToIntEnabled":false,"intToIntFrom":[],"intToIntTo":[]},"cost":{"leftEnabled":false,"leftValue":null,"rightValue":null,"rightEnabled":false},"bill":{"leftEnabled":false,"leftValue":null,"rightValue":null,"rightEnabled":false},"period":{"type":3,"fromDate":null,"fromTime":null,"toDate":null,"toTime":null},"types":{"call":false,"voicemail":false,"fax":false},"trunks":{"trunks":[]},"pbxes":{"pbxes":[]}},"grouping":[],"metric":["COUNT","COST","BILL"],"view":"TABLE","chart":{},"table":{"type":1,"sorters":{"field":"DATE","dest":"ASC"}}} },
            { id: '1-3', parentId: '1', name: _t('This month'), state: {"filter":{"destination":{"intToExtEnabled":false,"intToExtFrom":[],"intToExtTo":[],"extToIntEnabled":false,"extToIntFrom":[],"extToIntTo":[],"intToIntEnabled":false,"intToIntFrom":[],"intToIntTo":[]},"cost":{"leftEnabled":false,"leftValue":null,"rightValue":null,"rightEnabled":false},"bill":{"leftEnabled":false,"leftValue":null,"rightValue":null,"rightEnabled":false},"period":{"type":8,"fromDate":null,"fromTime":null,"toDate":null,"toTime":null},"types":{"call":false,"voicemail":false,"fax":false},"trunks":{"trunks":[]},"pbxes":{"pbxes":[]}},"grouping":[],"metric":["COUNT","COST","BILL"],"view":"TABLE","chart":{},"table":{"type":1,"sorters":{"field":"DATE","dest":"ASC"}}} },
            { id: '2-1', parentId: '2', name: _t('Today'), state: {"filter":{"destination":{"intToExtEnabled":false,"intToExtFrom":[],"intToExtTo":[],"extToIntEnabled":false,"extToIntFrom":[],"extToIntTo":[],"intToIntEnabled":false,"intToIntFrom":[],"intToIntTo":[]},"cost":{"leftEnabled":false,"leftValue":null,"rightValue":null,"rightEnabled":false},"bill":{"leftEnabled":false,"leftValue":null,"rightValue":null,"rightEnabled":false},"period":{"type":1,"fromDate":null,"fromTime":null,"toDate":null,"toTime":null},"types":{"call":false,"voicemail":false,"fax":false},"trunks":{"trunks":[]},"pbxes":{"pbxes":[]}},"grouping":["HOUR"],"metric":["COUNT_BY_DIRECTION","COST","BILL_BY_DIRECTION"],"view":"TABLE","chart":{},"table":{"type":2,"sorters":[{"field":"HOUR","dest":"ASC"}]}} },
            { id: '2-2', parentId: '2', name: _t('This week'),  state: {"filter":{"destination":{"intToExtEnabled":false,"intToExtFrom":[],"intToExtTo":[],"extToIntEnabled":false,"extToIntFrom":[],"extToIntTo":[],"intToIntEnabled":false,"intToIntFrom":[],"intToIntTo":[]},"cost":{"leftEnabled":false,"leftValue":null,"rightValue":null,"rightEnabled":false},"bill":{"leftEnabled":false,"leftValue":null,"rightValue":null,"rightEnabled":false},"period":{"type":3,"fromDate":null,"fromTime":null,"toDate":null,"toTime":null},"types":{"call":false,"voicemail":false,"fax":false},"trunks":{"trunks":[]},"pbxes":{"pbxes":[]}},"grouping":["DAY"],"metric":["COUNT_BY_DIRECTION","COST","BILL_BY_DIRECTION"],"view":"TABLE","chart":{},"table":{"type":2,"sorters":[{"field":"DAY","dest":"ASC"}]}} },
            { id: '2-3', parentId: '2', name: _t('This month'), state: {"filter":{"destination":{"intToExtEnabled":false,"intToExtFrom":[],"intToExtTo":[],"extToIntEnabled":false,"extToIntFrom":[],"extToIntTo":[],"intToIntEnabled":false,"intToIntFrom":[],"intToIntTo":[]},"cost":{"leftEnabled":false,"leftValue":null,"rightValue":null,"rightEnabled":false},"bill":{"leftEnabled":false,"leftValue":null,"rightValue":null,"rightEnabled":false},"period":{"type":8,"fromDate":null,"fromTime":null,"toDate":null,"toTime":null},"types":{"call":false,"voicemail":false,"fax":false},"trunks":{"trunks":[]},"pbxes":{"pbxes":[]}},"grouping":["DAY"],"metric":["COUNT_BY_DIRECTION","COST","BILL_BY_DIRECTION"],"view":"TABLE","chart":{},"table":{"type":2,"sorters":[{"field":"DAY","dest":"ASC"}]}} },
            { id: '2-4', parentId: '2', name: _t('This year'), state: {"filter":{"destination":{"intToExtEnabled":false,"intToExtFrom":[],"intToExtTo":[],"extToIntEnabled":false,"extToIntFrom":[],"extToIntTo":[],"intToIntEnabled":false,"intToIntFrom":[],"intToIntTo":[]},"cost":{"leftEnabled":false,"leftValue":null,"rightValue":null,"rightEnabled":false},"bill":{"leftEnabled":false,"leftValue":null,"rightValue":null,"rightEnabled":false},"period":{"type":15,"fromDate":null,"fromTime":null,"toDate":null,"toTime":null},"types":{"call":false,"voicemail":false,"fax":false},"trunks":{"trunks":[]},"pbxes":{"pbxes":[]}},"grouping":["MONTH"],"metric":["COUNT_BY_DIRECTION","COST","BILL_BY_DIRECTION"],"view":"TABLE","chart":{},"table":{"type":2,"sorters":[{"field":"MONTH","dest":"ASC"}]}} },
            { id: '3-1', parentId: '3', name: _t('Today'), state: {"filter":{"destination":{"intToExtEnabled":false,"intToExtFrom":[],"intToExtTo":[],"extToIntEnabled":false,"extToIntFrom":[],"extToIntTo":[],"intToIntEnabled":false,"intToIntFrom":[],"intToIntTo":[]},"cost":{"leftEnabled":false,"leftValue":null,"rightValue":null,"rightEnabled":false},"bill":{"leftEnabled":false,"leftValue":null,"rightValue":null,"rightEnabled":false},"period":{"type":1,"fromDate":null,"fromTime":null,"toDate":null,"toTime":null},"types":{"call":false,"voicemail":false,"fax":false},"trunks":{"trunks":[]},"pbxes":{"pbxes":[]}},"grouping":["GROUP"],"metric":["COUNT_BY_DIRECTION","COST","BILL_BY_DIRECTION"],"view":"TABLE","chart":{},"table":{"type":2,"sorters":{"field":"TOTAL_EVENTS","dest":"ASC"}}} },
            { id: '3-2', parentId: '3', name: _t('This week'), state: {"filter":{"destination":{"intToExtEnabled":false,"intToExtFrom":[],"intToExtTo":[],"extToIntEnabled":false,"extToIntFrom":[],"extToIntTo":[],"intToIntEnabled":false,"intToIntFrom":[],"intToIntTo":[]},"cost":{"leftEnabled":false,"leftValue":null,"rightValue":null,"rightEnabled":false},"bill":{"leftEnabled":false,"leftValue":null,"rightValue":null,"rightEnabled":false},"period":{"type":3,"fromDate":null,"fromTime":null,"toDate":null,"toTime":null},"types":{"call":false,"voicemail":false,"fax":false},"trunks":{"trunks":[]},"pbxes":{"pbxes":[]}},"grouping":["GROUP"],"metric":["COUNT_BY_DIRECTION","COST","BILL_BY_DIRECTION"],"view":"TABLE","chart":{},"table":{"type":2,"sorters":[{"field":"TOTAL_EVENTS","dest":"ASC"}]}} },
            { id: '3-3', parentId: '3', name: _t('This month'), state: {"filter":{"destination":{"intToExtEnabled":false,"intToExtFrom":[],"intToExtTo":[],"extToIntEnabled":false,"extToIntFrom":[],"extToIntTo":[],"intToIntEnabled":false,"intToIntFrom":[],"intToIntTo":[]},"cost":{"leftEnabled":false,"leftValue":null,"rightValue":null,"rightEnabled":false},"bill":{"leftEnabled":false,"leftValue":null,"rightValue":null,"rightEnabled":false},"period":{"type":8,"fromDate":null,"fromTime":null,"toDate":null,"toTime":null},"types":{"call":false,"voicemail":false,"fax":false},"trunks":{"trunks":[]},"pbxes":{"pbxes":[]}},"grouping":["GROUP"],"metric":["COUNT_BY_DIRECTION","COST","BILL_BY_DIRECTION"],"view":"TABLE","chart":{},"table":{"type":2,"sorters":{"field":"TOTAL_EVENTS","dest":"ASC"}}} },
            { id: '11-4', parentId: '11', name: _t('Today'), state: {"filter":{"destination":{"intToExtEnabled":true,"intToExtFrom":[],"intToExtTo":[],"extToIntEnabled":true,"extToIntFrom":[],"extToIntTo":[],"intToIntEnabled":false,"intToIntFrom":[],"intToIntTo":[]},"cost":{"leftEnabled":false,"leftValue":null,"rightValue":null,"rightEnabled":false},"bill":{"leftEnabled":false,"leftValue":null,"rightValue":null,"rightEnabled":false},"period":{"type":1,"fromDate":null,"fromTime":null,"toDate":null,"toTime":null},"types":{"call":false,"voicemail":false,"fax":false},"trunks":{"trunks":[]},"pbxes":{"pbxes":[]}},"grouping":["TRUNK"],"metric":["COUNT_BY_DIRECTION","COST","BILL_BY_DIRECTION"],"view":"TABLE","chart":{},"table":{"type":2,"sorters":{"field":"TOTAL_EVENTS","dest":"ASC"}}} },
            { id: '11-5', parentId: '11', name: _t('This week'), state: {"filter":{"destination":{"intToExtEnabled":true,"intToExtFrom":[],"intToExtTo":[],"extToIntEnabled":true,"extToIntFrom":[],"extToIntTo":[],"intToIntEnabled":false,"intToIntFrom":[],"intToIntTo":[]},"cost":{"leftEnabled":false,"leftValue":null,"rightValue":null,"rightEnabled":false},"bill":{"leftEnabled":false,"leftValue":null,"rightValue":null,"rightEnabled":false},"period":{"type":3,"fromDate":null,"fromTime":null,"toDate":null,"toTime":null},"types":{"call":false,"voicemail":false,"fax":false},"trunks":{"trunks":[]},"pbxes":{"pbxes":[]}},"grouping":["TRUNK"],"metric":["COUNT_BY_DIRECTION","COST","BILL_BY_DIRECTION"],"view":"TABLE","chart":{},"table":{"type":2,"sorters":{"field":"TOTAL_EVENTS","dest":"ASC"}}} },
            { id: '11-6', parentId: '11', name: _t('This month'), state: {"filter":{"destination":{"intToExtEnabled":true,"intToExtFrom":[],"intToExtTo":[],"extToIntEnabled":true,"extToIntFrom":[],"extToIntTo":[],"intToIntEnabled":false,"intToIntFrom":[],"intToIntTo":[]},"cost":{"leftEnabled":false,"leftValue":null,"rightValue":null,"rightEnabled":false},"bill":{"leftEnabled":false,"leftValue":null,"rightValue":null,"rightEnabled":false},"period":{"type":8,"fromDate":null,"fromTime":null,"toDate":null,"toTime":null},"types":{"call":false,"voicemail":false,"fax":false},"trunks":{"trunks":[]},"pbxes":{"pbxes":[]}},"grouping":["TRUNK"],"metric":["COUNT_BY_DIRECTION","COST","BILL_BY_DIRECTION"],"view":"TABLE","chart":{},"table":{"type":2,"sorters":{"field":"TOTAL_EVENTS","dest":"ASC"}}} },
            { id: '4-1', parentId: '4', name: _t('Failed outgoing'), state: {"filter":{"destination":{"intToExtEnabled":true,"intToExtFrom":[],"intToExtTo":[],"extToIntEnabled":false,"extToIntFrom":[],"extToIntTo":[],"intToIntEnabled":false,"intToIntFrom":[],"intToIntTo":[]},"cost":{"leftEnabled":false,"leftValue":null,"rightValue":null,"rightEnabled":false},"bill":{"leftEnabled":true,"leftValue":0,"rightValue":0,"rightEnabled":true},"period":{"type":8,"fromDate":null,"fromTime":null,"toDate":null,"toTime":null},"types":{"call":true,"voicemail":false,"fax":false},"trunks":{"trunks":[]},"pbxes":{"pbxes":[]}},"grouping":["GROUP"],"metric":["COUNT","COST","BILL"],"view":"TABLE","chart":{},"table":{"type":2,"sorters":{"field":"TOTAL_EVENTS","dest":"ASC"}}} },
            { id: '4-2', parentId: '4', name: _t('Missed incoming'), state: {"filter":{"destination":{"intToExtEnabled":false,"intToExtFrom":[],"intToExtTo":[],"extToIntEnabled":true,"extToIntFrom":[],"extToIntTo":[],"intToIntEnabled":false,"intToIntFrom":[],"intToIntTo":[]},"cost":{"leftEnabled":false,"leftValue":null,"rightValue":null,"rightEnabled":false},"bill":{"leftEnabled":true,"leftValue":0,"rightValue":0,"rightEnabled":true},"period":{"type":8,"fromDate":null,"fromTime":null,"toDate":null,"toTime":null},"types":{"call":true,"voicemail":false,"fax":false},"trunks":{"trunks":[]},"pbxes":{"pbxes":[]}},"grouping":["GROUP"],"metric":["COUNT","COST","BILL"],"view":"TABLE","chart":{},"table":{"type":2,"sorters":{"field":"TOTAL_EVENTS","dest":"ASC"}}} },
            { id: '4-3', parentId: '4', name: _t('Faxes sent'), state: {"filter":{"destination":{"intToExtEnabled":true,"intToExtFrom":[],"intToExtTo":[],"extToIntEnabled":false,"extToIntFrom":[],"extToIntTo":[],"intToIntEnabled":false,"intToIntFrom":[],"intToIntTo":[]},"cost":{"leftEnabled":false,"leftValue":null,"rightValue":null,"rightEnabled":false},"bill":{"leftEnabled":true,"leftValue":0,"rightValue":null,"rightEnabled":false},"period":{"type":8,"fromDate":null,"fromTime":null,"toDate":null,"toTime":null},"types":{"call":false,"voicemail":false,"fax":true},"trunks":{"trunks":[]},"pbxes":{"pbxes":[]}},"grouping":["GROUP"],"metric":["COUNT","COST","BILL"],"view":"TABLE","chart":{},"table":{"type":2,"sorters":[{"field":"USER_GROUP_NAME","dest":"ASC"}]}} },
            { id: '4-4', parentId: '4', name: _t('Faxes received'), state: {"filter":{"destination":{"intToExtEnabled":false,"intToExtFrom":[],"intToExtTo":[],"extToIntEnabled":true,"extToIntFrom":[],"extToIntTo":[],"intToIntEnabled":false,"intToIntFrom":[],"intToIntTo":[]},"cost":{"leftEnabled":false,"leftValue":null,"rightValue":null,"rightEnabled":false},"bill":{"leftEnabled":true,"leftValue":0,"rightValue":null,"rightEnabled":false},"period":{"type":8,"fromDate":null,"fromTime":null,"toDate":null,"toTime":null},"types":{"call":false,"voicemail":false,"fax":true},"trunks":{"trunks":[]},"pbxes":{"pbxes":[]}},"grouping":["GROUP"],"metric":["COUNT","COST","BILL"],"view":"TABLE","chart":{},"table":{"type":2,"sorters":[{"field":"USER_GROUP_NAME","dest":"ASC"}]}} },
            { id: '4-5', parentId: '4', name: _t('Voicemail'), state: {"filter":{"destination":{"intToExtEnabled":false,"intToExtFrom":[],"intToExtTo":[],"extToIntEnabled":true,"extToIntFrom":[],"extToIntTo":[],"intToIntEnabled":false,"intToIntFrom":[],"intToIntTo":[]},"cost":{"leftEnabled":false,"leftValue":null,"rightValue":null,"rightEnabled":false},"bill":{"leftEnabled":true,"leftValue":0,"rightValue":null,"rightEnabled":false},"period":{"type":8,"fromDate":null,"fromTime":null,"toDate":null,"toTime":null},"types":{"call":false,"voicemail":true,"fax":false},"trunks":{"trunks":[]},"pbxes":{"pbxes":[]}},"grouping":["GROUP"],"metric":["COUNT","COST","BILL"],"view":"TABLE","chart":{},"table":{"type":2,"sorters":[{"field":"USER_GROUP_NAME","dest":"ASC"}]}} },
            { id: '5-1', parentId: '5', name: _t('Country'), state: {"filter":{"destination":{"intToExtEnabled":true,"intToExtFrom":[],"intToExtTo":[],"extToIntEnabled":false,"extToIntFrom":[],"extToIntTo":[],"intToIntEnabled":false,"intToIntFrom":[],"intToIntTo":[]},"cost":{"leftEnabled":false,"leftValue":null,"rightValue":null,"rightEnabled":false},"bill":{"leftEnabled":false,"leftValue":null,"rightValue":null,"rightEnabled":false},"period":{"type":8,"fromDate":null,"fromTime":null,"toDate":null,"toTime":null},"types":{"call":false,"voicemail":false,"fax":false},"trunks":{"trunks":[]},"pbxes":{"pbxes":[]}},"grouping":["COUNTRY"],"metric":["COUNT_BY_STATUS","COST","BILL"],"view":"TABLE","chart":{},"table":{"type":2,"sorters":[{"field":"COUNTRY","dest":"ASC"}]}} },
            { id: '5-2', parentId: '5', name: _t('Call Class'), state: {"filter":{"destination":{"intToExtEnabled":true,"intToExtFrom":[],"intToExtTo":[],"extToIntEnabled":false,"extToIntFrom":[],"extToIntTo":[],"intToIntEnabled":false,"intToIntFrom":[],"intToIntTo":[]},"cost":{"leftEnabled":false,"leftValue":null,"rightValue":null,"rightEnabled":false},"bill":{"leftEnabled":false,"leftValue":null,"rightValue":null,"rightEnabled":false},"period":{"type":8,"fromDate":null,"fromTime":null,"toDate":null,"toTime":null},"types":{"call":false,"voicemail":false,"fax":false},"trunks":{"trunks":[]},"pbxes":{"pbxes":[]}},"grouping":["CLASS"],"metric":["COUNT_BY_STATUS","COST","BILL"],"view":"TABLE","chart":{},"table":{"type":2,"sorters":[{"field":"CLASS","dest":"ASC"}]}} },
            { id: '12-3', parentId: '12', name: _t('Country'), state: {"filter":{"destination":{"intToExtEnabled":false,"intToExtFrom":[],"intToExtTo":[],"extToIntEnabled":true,"extToIntFrom":[],"extToIntTo":[],"intToIntEnabled":false,"intToIntFrom":[],"intToIntTo":[]},"cost":{"leftEnabled":false,"leftValue":null,"rightValue":null,"rightEnabled":false},"bill":{"leftEnabled":false,"leftValue":null,"rightValue":null,"rightEnabled":false},"period":{"type":8,"fromDate":null,"fromTime":null,"toDate":null,"toTime":null},"types":{"call":false,"voicemail":false,"fax":false},"trunks":{"trunks":[]},"pbxes":{"pbxes":[]}},"grouping":["COUNTRY"],"metric":["COUNT_BY_STATUS","COST","BILL"],"view":"TABLE","chart":{},"table":{"type":2,"sorters":[{"field":"COUNTRY","dest":"ASC"}]}} },
            { id: '12-4', parentId: '12', name: _t('Call Class'), state: {"filter":{"destination":{"intToExtEnabled":false,"intToExtFrom":[],"intToExtTo":[],"extToIntEnabled":true,"extToIntFrom":[],"extToIntTo":[],"intToIntEnabled":false,"intToIntFrom":[],"intToIntTo":[]},"cost":{"leftEnabled":false,"leftValue":null,"rightValue":null,"rightEnabled":false},"bill":{"leftEnabled":false,"leftValue":null,"rightValue":null,"rightEnabled":false},"period":{"type":8,"fromDate":null,"fromTime":null,"toDate":null,"toTime":null},"types":{"call":false,"voicemail":false,"fax":false},"trunks":{"trunks":[]},"pbxes":{"pbxes":[]}},"grouping":["CLASS"],"metric":["COUNT_BY_STATUS","COST","BILL"],"view":"TABLE","chart":{},"table":{"type":2,"sorters":[{"field":"CLASS","dest":"ASC"}]}} },
            { id: '6-1', parentId: '6', name: _t('User'), state: {"filter":{"destination":{"intToExtEnabled":true,"intToExtFrom":[],"intToExtTo":[],"extToIntEnabled":false,"extToIntFrom":[],"extToIntTo":[],"intToIntEnabled":false,"intToIntFrom":[],"intToIntTo":[]},"cost":{"leftEnabled":false,"leftValue":null,"rightValue":null,"rightEnabled":false},"bill":{"leftEnabled":true,"leftValue":0,"rightValue":null,"rightEnabled":false},"period":{"type":8,"fromDate":null,"fromTime":null,"toDate":null,"toTime":null},"types":{"call":false,"voicemail":false,"fax":false},"trunks":{"trunks":[]},"pbxes":{"pbxes":[]}},"grouping":["USER"],"metric":["COUNT","COST","BILL"],"view":"TABLE","chart":{},"table":{"type":2,"sorters":[{"field":"USER_NAME","dest":"ASC"}]}} },
            { id: '6-2', parentId: '6', name: _t('Group'), state: {"filter":{"destination":{"intToExtEnabled":true,"intToExtFrom":[],"intToExtTo":[],"extToIntEnabled":false,"extToIntFrom":[],"extToIntTo":[],"intToIntEnabled":false,"intToIntFrom":[],"intToIntTo":[]},"cost":{"leftEnabled":false,"leftValue":null,"rightValue":null,"rightEnabled":false},"bill":{"leftEnabled":true,"leftValue":0,"rightValue":null,"rightEnabled":false},"period":{"type":8,"fromDate":null,"fromTime":null,"toDate":null,"toTime":null},"types":{"call":false,"voicemail":false,"fax":false},"trunks":{"trunks":[]},"pbxes":{"pbxes":[]}},"grouping":["GROUP"],"metric":["COUNT","COST","BILL"],"view":"TABLE","chart":{},"table":{"type":2,"sorters":{"field":"TOTAL_COST","dest":"ASC"}}} },
            { id: '6-3', parentId: '6', name: _t('Trunk'), state: {"filter":{"destination":{"intToExtEnabled":true,"intToExtFrom":[],"intToExtTo":[],"extToIntEnabled":false,"extToIntFrom":[],"extToIntTo":[],"intToIntEnabled":false,"intToIntFrom":[],"intToIntTo":[]},"cost":{"leftEnabled":false,"leftValue":null,"rightValue":null,"rightEnabled":false},"bill":{"leftEnabled":true,"leftValue":0,"rightValue":null,"rightEnabled":false},"period":{"type":8,"fromDate":null,"fromTime":null,"toDate":null,"toTime":null},"types":{"call":false,"voicemail":false,"fax":false},"trunks":{"trunks":[]},"pbxes":{"pbxes":[]}},"grouping":["TRUNK"],"metric":["COUNT","COST","BILL"],"view":"TABLE","chart":{},"table":{"type":2,"sorters":{"field":"TOTAL_COST","dest":"ASC"}}} },
            { id: '6-4', parentId: '6', name: _t('Call Class'), state: {"filter":{"destination":{"intToExtEnabled":true,"intToExtFrom":[],"intToExtTo":[],"extToIntEnabled":false,"extToIntFrom":[],"extToIntTo":[],"intToIntEnabled":false,"intToIntFrom":[],"intToIntTo":[]},"cost":{"leftEnabled":false,"leftValue":null,"rightValue":null,"rightEnabled":false},"bill":{"leftEnabled":true,"leftValue":0,"rightValue":null,"rightEnabled":false},"period":{"type":8,"fromDate":null,"fromTime":null,"toDate":null,"toTime":null},"types":{"call":false,"voicemail":false,"fax":false},"trunks":{"trunks":[]},"pbxes":{"pbxes":[]}},"grouping":["CLASS"],"metric":["COUNT","COST","BILL"],"view":"TABLE","chart":{},"table":{"type":2,"sorters":{"field":"TOTAL_COST","dest":"ASC"}}} },
            { id: '6-5', parentId: '6', name: _t('Destination'), state: {"filter":{"destination":{"intToExtEnabled":true,"intToExtFrom":[],"intToExtTo":[],"extToIntEnabled":false,"extToIntFrom":[],"extToIntTo":[],"intToIntEnabled":false,"intToIntFrom":[],"intToIntTo":[]},"cost":{"leftEnabled":false,"leftValue":null,"rightValue":null,"rightEnabled":false},"bill":{"leftEnabled":true,"leftValue":0,"rightValue":null,"rightEnabled":false},"period":{"type":8,"fromDate":null,"fromTime":null,"toDate":null,"toTime":null},"types":{"call":false,"voicemail":false,"fax":false},"trunks":{"trunks":[]},"pbxes":{"pbxes":[]}},"grouping":["COUNTRY"],"metric":["COUNT","COST","BILL"],"view":"TABLE","chart":{},"table":{"type":2,"sorters":{"field":"TOTAL_COST","dest":"ASC"}}} },
            { id: '7-1', parentId: '7', name: _t('Today'), state: {"filter":{"destination":{"intToExtEnabled":false,"intToExtFrom":[],"intToExtTo":[],"extToIntEnabled":false,"extToIntFrom":[],"extToIntTo":[],"intToIntEnabled":false,"intToIntFrom":[],"intToIntTo":[]},"cost":{"leftEnabled":false,"leftValue":null,"rightValue":null,"rightEnabled":false},"bill":{"leftEnabled":false,"leftValue":null,"rightValue":null,"rightEnabled":false},"period":{"type":1,"fromDate":null,"fromTime":null,"toDate":null,"toTime":null},"types":{"call":false,"voicemail":false,"fax":false},"trunks":{"trunks":[]},"pbxes":{"pbxes":[]}},"grouping":["GROUP"],"metric":["COUNT","COST","BILL"],"view":"TABLE","chart":{},"table":{"type":2,"sorters":{"field":"TOTAL_EVENTS","dest":"ASC"}}} },
            { id: '7-2', parentId: '7', name: _t('This week'), state: {"filter":{"destination":{"intToExtEnabled":false,"intToExtFrom":[],"intToExtTo":[],"extToIntEnabled":false,"extToIntFrom":[],"extToIntTo":[],"intToIntEnabled":false,"intToIntFrom":[],"intToIntTo":[]},"cost":{"leftEnabled":false,"leftValue":null,"rightValue":null,"rightEnabled":false},"bill":{"leftEnabled":false,"leftValue":null,"rightValue":null,"rightEnabled":false},"period":{"type":3,"fromDate":null,"fromTime":null,"toDate":null,"toTime":null},"types":{"call":false,"voicemail":false,"fax":false},"trunks":{"trunks":[]},"pbxes":{"pbxes":[]}},"grouping":["GROUP"],"metric":["COUNT","COST","BILL"],"view":"TABLE","chart":{},"table":{"type":2,"sorters":{"field":"TOTAL_EVENTS","dest":"ASC"}}} },
            { id: '7-3', parentId: '7', name: _t('This month'), state: {"filter":{"destination":{"intToExtEnabled":false,"intToExtFrom":[],"intToExtTo":[],"extToIntEnabled":false,"extToIntFrom":[],"extToIntTo":[],"intToIntEnabled":false,"intToIntFrom":[],"intToIntTo":[]},"cost":{"leftEnabled":false,"leftValue":null,"rightValue":null,"rightEnabled":false},"bill":{"leftEnabled":false,"leftValue":null,"rightValue":null,"rightEnabled":false},"period":{"type":8,"fromDate":null,"fromTime":null,"toDate":null,"toTime":null},"types":{"call":false,"voicemail":false,"fax":false},"trunks":{"trunks":[]},"pbxes":{"pbxes":[]}},"grouping":["GROUP"],"metric":["COUNT","COST","BILL"],"view":"TABLE","chart":{},"table":{"type":2,"sorters":{"field":"TOTAL_EVENTS","dest":"ASC"}}} },
            { id: '8-1', parentId: '8', name: _t('Most called numbers'), state: {"filter":{"destination":{"intToExtEnabled":true,"intToExtFrom":[],"intToExtTo":[],"extToIntEnabled":false,"extToIntFrom":[],"extToIntTo":[],"intToIntEnabled":false,"intToIntFrom":[],"intToIntTo":[]},"cost":{"leftEnabled":false,"leftValue":null,"rightValue":null,"rightEnabled":false},"bill":{"leftEnabled":false,"leftValue":null,"rightValue":null,"rightEnabled":false},"period":{"type":8,"fromDate":null,"fromTime":null,"toDate":null,"toTime":null},"types":{"call":false,"voicemail":false,"fax":false},"trunks":{"trunks":[]},"pbxes":{"pbxes":[]}},"grouping":["NUMBER"],"metric":["COUNT_BY_STATUS","COST","BILL"],"view":"TABLE","chart":{},"table":{"type":2,"sorters":{"field":"TOTAL_EVENTS","dest":"ASC"}}} },
            { id: '8-2', parentId: '8', name: _t('Most received call numbers'), state: {"filter":{"destination":{"intToExtEnabled":false,"intToExtFrom":[],"intToExtTo":[],"extToIntEnabled":true,"extToIntFrom":[],"extToIntTo":[],"intToIntEnabled":false,"intToIntFrom":[],"intToIntTo":[]},"cost":{"leftEnabled":false,"leftValue":null,"rightValue":null,"rightEnabled":false},"bill":{"leftEnabled":false,"leftValue":null,"rightValue":null,"rightEnabled":false},"period":{"type":8,"fromDate":null,"fromTime":null,"toDate":null,"toTime":null},"types":{"call":false,"voicemail":false,"fax":false},"trunks":{"trunks":[]},"pbxes":{"pbxes":[]}},"grouping":["NUMBER"],"metric":["COUNT_BY_STATUS","COST","BILL"],"view":"TABLE","chart":{},"table":{"type":2,"sorters":{"field":"TOTAL_EVENTS","dest":"ASC"}}} },
            { id: '8-3', parentId: '8', name: _t('Most called countries'), state: {"filter":{"destination":{"intToExtEnabled":true,"intToExtFrom":[],"intToExtTo":[],"extToIntEnabled":true,"extToIntFrom":[],"extToIntTo":[],"intToIntEnabled":false,"intToIntFrom":[],"intToIntTo":[]},"cost":{"leftEnabled":false,"leftValue":null,"rightValue":null,"rightEnabled":false},"bill":{"leftEnabled":false,"leftValue":null,"rightValue":null,"rightEnabled":false},"period":{"type":8,"fromDate":null,"fromTime":null,"toDate":null,"toTime":null},"types":{"call":false,"voicemail":false,"fax":false},"trunks":{"trunks":[]},"pbxes":{"pbxes":[]}},"grouping":["COUNTRY"],"metric":["COUNT_BY_DIRECTION","COST","BILL_BY_DIRECTION"],"view":"TABLE","chart":{},"table":{"type":2,"sorters":{"field":"TOTAL_EVENTS","dest":"ASC"}}} }
        ]
        
        this.store = Ext.create('Ext.data.JsonStore', {
            fields: [
                'id',
                'name',
                'active',
                'side'
            ],
            data: this.verify(this.categories)
        });
        
        this.tpl = new Ext.XTemplate(
            '<div class="w-reports-picker-tl"><div class="w-reports-picker-tr"><div class="w-reports-picker-tt">',
                sprintf('<div class="w-reports-picker-arrow">%(reportSelect)s</div>', { reportSelect : _t('Predefined Filters') }),
            '</div></div></div>',
            '<div class="w-reports-picker-cl"><div class="w-reports-picker-cr">',
            '<tpl for=".">',
                '<div class="category <tpl if="active == 1">category-active</tpl>">',
                    '<div class="category-arrow">{name}</div>',
                '</div>',
            '</tpl>',
            '</div></div>',
            '<div class="w-reports-picker-bl"><div class="w-reports-picker-br"><div class="w-reports-picker-bb"></div></div></div>'
        );
                
        this.selection = Ext.create('App.view.reports.picker.Selection');
        this.selection.on('selectReport', this.onSelectReport, this);
        this.selection.on('deleteReport', this.onDeleteReport, this);
        
        this.itemSelector = 'div.category';
        this.callParent(arguments);
        
        this.bind = true;
    },
    show: function() {
        // Show component
        if (this.isVisible()) {
            return;
        }
        
        Ext.getDoc().on('mousedown', this.collapseWheel, this);
        Ext.EventManager.onWindowResize(this.align, this);
        
        this.align();
        this.callParent(arguments);
        
        // Verify previos state
        var i, r;
        
        for (i=0; i < this.store.getCount(); i++) {
            r = this.store.getAt(i);
            
            if (r.get('active') == 1) {
                r.set('active', 0);
            }
        }
        
        if (this.bind)  {
            this.bindView();
            this.bind = false;
        }

        if(!this.KeyMapOnEsc) {
            this.KeyMapOnEsc = new Ext.util.KeyMap(Ext.getBody(), [{
               key: Ext.EventObject.ESC,
               defaultEventAction: 'preventDefault',
               scope: this,
               fn: this.hide
            }]);
        } else {
            this.KeyMapOnEsc.enable();
        }

    },
    
    hide: function() {
        Ext.getDoc().un('mousedown', this.collapseWheel, this);
        Ext.EventManager.removeResizeListener(this.align, this);
        
        if (this.selection.isVisible()) {
            this.selection.hide();
        }
        
        this.callParent(arguments);

        this.KeyMapOnEsc.disable();
        this.fireEvent('collapse');
    },
    align: function() {
        var trgPos = this.target.getPosition();
        var trgLeft = trgPos[0] - 10;
        var trgTop = trgPos[1] - 5;
        var trgWidth = this.target.getWidth();
        
        if (trgWidth < 160) {
            trgWidth = 160;
        }
        
        this.setWidth(trgWidth);
        this.setPosition(trgLeft, trgTop, false);
        
        if (this.selection.isVisible()) {
            var target = Ext.get(this.getNode(this.selectionRecord));
            var left = target.getLeft();
            var top = target.getTop();
            var width = target.getWidth();
            
            this.selection.align(left + width + 2, top - 2, []);
        }
    },
    verify: function(categories) {
        var i;
        
        for (i=0; i < categories.length; i++) {
            if (i == 0) {
                categories[i]['side'] = 1;
            } else if(i == categories.length - 1) {
                categories[i]['side'] = 2;
            } else {
                categories[i]['side'] = 0;
            }
        }
        
        return categories;
    },
    
    bindView: function(){
        this.headEl = this.getEl().down('div.w-reports-picker-arrow');
        this.headEl.on('click', this.onHeadElClick, this);            
    },
    
    collapseWheel: function(event, element) {
        if (!event.within(this.el, false, true)) {
            if (this.selection.isVisible() && event.within(this.selection.el, false, true)) {
                return;
            }
            
            this.hide();
        }
    },
    onItemClick: function(record, item) {
        if (record.get('active') == 1) {
            record.set('active', 0);
            this.selection.hide();
            return;
        }
        
        var target = Ext.get(item);
        var left = target.getLeft();
        var top = target.getTop();
        var width = target.getWidth();
        var type = 'prepared';

        // Unactive other items
        var i, r;        
        for (i=0; i < this.store.getCount(); i++) {
            r = this.store.getAt(i);
            
            if (r.get('active') == 1) {
                r.set('active', 0);
            }
        }
        
        record.set('active', 1);

        // Collect selections that matched to current item
        var id = record.get('id');
        var reports = new Array();

        for (i=0; i < this.reports.length; i++) {
            if (id == this.reports[i]['parentId']) {
                reports.push(this.reports[i]);
            }
        }

        // Define reports type (that need to show correctly a message when reports is empty)
        if (id == '9') {
            type = 'shared';
        } else if (id == '10') {
            type = 'personal';
        }

        this.selectionTarget = target;
        this.selectionRecord = record;

        // Show selection container, with needed reports
        this.selection.show(left + width + 2, top - 2, reports, type);

        if (type != 'prepared') {
            // We should fetch reports form a server.
            if (type == 'shared') {
                this.fireEvent('fetchSharedReports', this.onFetchedSharedReports, this);
            } else if (type == 'personal') {
                this.fireEvent('fetchPersonalReports', this.onFetchedPersonalReports, this);
            }
        }
    },
    
    onHeadElClick: function() {
        this.hide();
    },

    /**
     * Fires when user clicks to a single report at selection view, we should invoke selectReport event to subscribers.
     */
    onSelectReport: function(report) {
        this.selection.hide();
        this.hide();
        
        this.fireEvent('selectReport', report);
    },

    /**
     * Fires when user clicks to a delete button on single report at selection view, we should invoke deleteReport event
     * to subscribers.
     */
    onDeleteReport: function(report) {
        this.selection.hide();
        this.hide();
        
        this.fireEvent('deleteReport', report);
    },

    /**
     * Fires when Shared reports has been successfully requested from the server, we should show that reports.
     */
    onFetchedSharedReports: function(reports) {
        this.selection.fireEvent('showSharedReports', reports);
    },

    /**
     * Fires when Personal reports has been successfully requested from the server, we should show that reports.
     */
    onFetchedPersonalReports: function(reports) {
        this.selection.fireEvent('showPersonalReports', reports);
    }
});
