Ext.define('App.view.viewer.Metric', {
    extend: 'App.view.viewport.PickerButton',
    alias : 'widget.viewerMetric',
    text: _t('Metric'),
    width: 140,
    margin: '0 0 0 10',
    disabled: true,
    initComponent: function() {
        this.callParent(arguments);
    },
    afterRender: function() {
        this.callParent(arguments);

        // Attach picker
        this.picker = Ext.create('App.view.metric.Picker', {
            target: this.getEl()
        });
        this.picker.on('change', this.onMetricPickerChange, this);
        this.picker.on('grpElClick', this.onGrpElClick, this);
    },
    onMetricPickerChange: function(state) {
        this.fireEvent('change', state);
    },
    getPicker: function() {
        return this.picker;
    },
    onClick: function() {
        if (this.getPicker().allowList){
            this.picker.show();
        }
    },
    changeStatus: function(allow) {
        this.getPicker().allowList = allow;
        this[allow?'enable':'disable'](!allow);
        this.getPicker().refresh();
    },
    onGrpElClick: function() {
        this.fireEvent('grpElClick');
    }
});