/**
 * Created by PyCharm.
 * User: Artyom Trityak
 * Date: 1/5/12
 * Time: 5:21 PM
 * To change this template use File | Settings | File Templates.
 */
Ext.define('App.view.viewer.chart.type.PieChart', {
    extend: 'App.view.viewer.chart.type.DefaultChart',

    requires: [
        'App.view.viewer.chart.type.DefaultChart'
    ],

    animate: true,

    checkPossibilityToDraw: function() {
        var draw = true;
        var drawReason = "";
        console.log("LENNNNNNNN");
        console.log(this.options.records.length);
        if (this.options.totalVal === 0) {
            draw = false;
            drawReason = "NO_DATA";
        }
        var counterFields = 0;
        for (var key in this.options.records[0]) {
            console.log(key);
            if (this.options.records[0].hasOwnProperty(key) && !key.match(/_GROUPING_NAME$/)) {
                counterFields++;
            }
        }
        console.log("COLLLLLLLLL");
        console.log(counterFields);
        if (counterFields > 2) {
            draw = false;
            drawReason = "NOT_SUPPORTED_METRIC";
        }

        this.options.draw = draw;
        this.options.drawReason = drawReason;
    },

    createSeries: function(fields, pointsCount) {
        var me = this,
            labelSize = 12;

        if (pointsCount){
            if (pointsCount <= 10)
                labelSize = 32;
            else if (pointsCount < 20)
                labelSize = 20;
            else if (pointsCount < 40)
                labelSize = 15;
            else
                labelSize = 12;
        }
        this.insetPadding = 20;
        this._reconfigurePieData(fields);
        var series = [];
        var elem = {
            type: 'custompie',
            field: fields.yFields[0],
            showInLegend: true,
            label: {
                field: fields.yFields[0],
                display: 'rotate',
                contrast: true,
                font: labelSize+'px Arial',
                renderer: function(v) {
                    var prc = Math.round((v / me.options.totalVal) * 10000)/100;
                    if (me.options.isLabelVisible){
                        return prc + '%  ('+me._formatTipData(v)+')';
                    } else {
                        return prc + '%';
                    }
                }
            },
            title: this.getFormattedLegend(fields),
            highlight: {
                segment: {
                    margin: 20
                }
            },
            style: {
                'stroke-width': 1,
                'stroke': '#fff'
            },
            tips: this.createTip()
        };
        series.push(elem);
        return series;
    },

    createAxes: function() {
        return false;
    },

    createTip: function() {
        var self = this;
        var tip = {
            trackMouse: true,
            minWidth: 200,
            renderer: function(storeItem, item) {
                var itemVal = self._formatTipData(storeItem.get(self.options.fields.yFields[0]));
                var tooltip = self.getFormattedField(storeItem.get(self.options.fields.xGroupField)) + ' <br/> ' + itemVal;
                this.update(tooltip);
            }
        }
        return tip;
    },

    _reconfigurePieData: function(fields) {
        var keysCount = 0;
        var maxKeys = 13;
        var otherVal = 0;
        var newRecords = [];
        var totalVal = 0;

        console.log('SORTING');
        this.options.records.sort(function(rec1, rec2) {
            var result = 0;
            if (parseFloat(rec1[fields.yFields[0]], 10) > parseFloat(rec2[fields.yFields[0]], 10)) {
                result = -1;
            } else if (parseFloat(rec1[fields.yFields[0]], 10) < parseFloat(rec2[fields.yFields[0]], 10)) {
                result = 1;
            }
            return result;
        });
        console.log('-SORTING');

        for (var i in this.options.records) {
            var fieldVal = parseFloat(this.options.records[i][fields.yFields[0]], 10);
            if (!isNaN(fieldVal)) {
                totalVal += fieldVal;
            }
            if (this.options.records[i][fields.xGroupField] == null || this.options.records[i][fields.xGroupField] == '' || this.options.records[i][fields.xGroupField] == undefined || keysCount > maxKeys) {
                if (!isNaN(fieldVal)) {
                    otherVal += fieldVal;
                }
            } else {
                console.log('PUSH!');
                console.log(this.options.records[i][fields.yFields[0]]);
                newRecords.push(this.options.records[i]);
            }
            keysCount++;
        }
        if (otherVal > 0) {
            var otherRec = {};
            otherRec[fields.xGroupField] = 'other';
            otherRec[fields.yFields[0]] = otherVal;
            newRecords.push(otherRec);
        }
        this.options.totalVal = totalVal;
        this.options.records = newRecords;
    },

    getFormattedLegend: function(fields) {
        var titles = [];
        for (var i in this.options.records) {
            if (this.options.records[i][fields.xGroupField] !== 'other') {
                var title = this.getFormattedField(this.options.records[i][fields.xGroupField]);
            } else {
                title = _t('Other');
            }
            titles.push(title);
        }
        return titles;
    }

});
