#!/usr/bin/php
<?php
ini_set('error_reporting', '255');


if (!isset($argv[1])){
    die( "Usage: php <kite_translations_file_name.csv> [make_file]". PHP_EOL);
}

/**/
if (isset($argv[2]) && $argv[2] == 'make_file'){
    $translations = array(
        'en' => array(),
        'it' => array(),
        'fr' => array(),
        'de' => array(),
    );
    $translationKeys = array();
    $out_filename = $argv[1];
    $read_filename = __DIR__.'/../../js/lang/main.json';

    $addItTrans = array();
    foreach (json_decode(file_get_contents('lng_it.js'), true) as $value) {
        $addItTrans = array_merge($addItTrans, $value);
    }
    $addFrTrans = array();
    foreach (json_decode(file_get_contents('lng_fr.js'), true) as $value) {
        $addFrTrans = array_merge($addFrTrans, $value);
    }
    $addDeTrans = array();
    foreach (json_decode(file_get_contents('lng_de.js'), true) as $value) {
        $addDeTrans = array_merge($addDeTrans, $value);
    }
    

    $fobjects = new RecursiveIteratorIterator(new RecursiveDirectoryIterator(realpath('../app')));
    foreach($fobjects as $fname => $fobject){
        if (!is_file($fname))
            continue;
        echo "$fname\n";
        preg_match_all('/@#(.*?)#@/', file_get_contents($fname), $matches);
        if (is_array( $matches[1]) && count($matches[1]) ){
            foreach ($matches[1] as $lngKey) {
                if (array_search($lngKey, $translationKeys) === false )
                    $translationKeys[] = $lngKey;
            }
        }
        
    }

    //

    $fp = fopen($out_filename, 'w');

    fputcsv($fp, array('','ID','English', 'Italian', 'French', 'German', 'comment'),',');
    foreach ($translationKeys as $translationKey){
        $line = array(
            0=>'',
            1=>$translationKey,
            2=>$translationKey,
            3=>@$addItTrans[$translationKey],
            4=>@$addFrTrans[$translationKey],
            5=>@$addDeTrans[$translationKey]
        );
        fputcsv($fp, $line,',');
    }
    fclose($fp);

    exit( 'DONE'. PHP_EOL );
}
/**/


$input_filename_csv = $argv[1];
$output_filename_csv = __DIR__.'/lang__lang__.js';

if (!file_exists($input_filename_csv)) {
    die('File ' . $input_filename_csv . ' is not present' . PHP_EOL);
}


if (($csv_handle = fopen($input_filename_csv, "r")) === false) {
    die('Cannot open file ' . $input_filename_csv . PHP_EOL);
}

// get the first csv row to get the header values
if (($csv_columns = fgetcsv($csv_handle, 1024, ",")) === false) {
    die('Cannot read the first row from ' . $input_filename_csv . PHP_EOL);
}

$csv_columns_tmp = $csv_columns;
foreach ($csv_columns_tmp as $key => $value) {
    $csv_columns[$key] = strtolower($value);
}
unset($csv_columns_tmp);

$csv_columns = array_flip($csv_columns);

if (!isset($csv_columns['id']) || !isset($csv_columns['english']) || !isset($csv_columns['italian']) || !isset($csv_columns['french']) || !isset($csv_columns['german'])) {
    die('Cannot get the languages positions from the first row of the file ' . $input_filename_csv . PHP_EOL);
}

unset($csv_columns['comment'],$csv_columns['row']);

$big_translation_arr = array(
    'en' => array(),
    'it' => array(),
    'fr' => array(),
    'de' => array(),
);
$known_languages = array('english','italian','french','german');

$rows_counter = 1;
while (($csv_row = fgetcsv($csv_handle, 0, ",")) !== false) {
    $rows_counter++;
    foreach ($csv_columns as $value => $position) {
        if (!isset($csv_row[$position])) {
            echo 'WARNING: Row #' . $rows_counter . '. Column ' . $value . ' is not set: (' . implode('|', $csv_row) . ')' . PHP_EOL;
        }
    }

    if (!isset($csv_row[$csv_columns['id']]))
        continue;

    foreach ($known_languages as $known_language) {
        if (!isset($csv_row[$csv_columns[$known_language]]))
            $csv_row[$csv_columns[$known_language]] = '';
    }

    $big_translation_arr['en'][$csv_row[$csv_columns['id']]] = $csv_row[$csv_columns['english']];
    $big_translation_arr['it'][$csv_row[$csv_columns['id']]] = $csv_row[$csv_columns['italian']];
    $big_translation_arr['fr'][$csv_row[$csv_columns['id']]] = $csv_row[$csv_columns['french']];
    $big_translation_arr['de'][$csv_row[$csv_columns['id']]] = $csv_row[$csv_columns['german']];
}

////>>>>>>>>>>Check if all keys exists in translation doc>>>>>>>>>>>>>>>
    $checkKeys = array();
    $fobjects = new RecursiveIteratorIterator(new RecursiveDirectoryIterator(realpath('../app')));
    foreach($fobjects as $fname => $fobject){
        if (!is_file($fname))
            continue;
        preg_match_all("/_t\('(.*?)'\)/", file_get_contents($fname), $matches);
        if (is_array( $matches[1]) && count($matches[1]) ){
            foreach ($matches[1] as $lngKey) {
                $lngKey = str_replace('\\\'', '\'', $lngKey);
                if (array_search($lngKey, $checkKeys) === false )
                    $checkKeys[] = $lngKey;
            }
        }
        
    }
    $someNotTranslated = false;
    foreach($checkKeys as $checkKey){
    	if ( !isset( $big_translation_arr['en'][$checkKey] )){
    		$someNotTranslated = true;
    		echo "$checkKey - not translated\n";
    	}
    }
    if ($someNotTranslated)
        exit('There are not translated keys for english!');

    foreach($big_translation_arr['en'] as $translationKey=>$translationEng){
    	if ( array_search($translationKey, $checkKeys)===false ){
    		echo PHP_EOL.PHP_EOL."Take a look $translationKey - not used\n".PHP_EOL ;
    	}
    }
////<<<<<<<<<<<<<<<<<<<<<<<<<

//Split by point
$translationsNested = array();
foreach ($big_translation_arr as $lang=>$values){
    $translationsNested[$lang] = array();
    foreach ($values as $key => $val){
        if ( strpos($key, '.') !==false ) {
            $translationNestedKeys = explode('.', $key);
            $translationsNested[$lang][$translationNestedKeys[0]][$translationNestedKeys[1]] = $val;
        } else {
            $translationsNested[$lang][$key] = $val;
        }
    }
}
foreach ($big_translation_arr as $lang=>$values){
    $encoded = json_encode($values, JSON_PRETTY_PRINT);
    //$encoded = substr_replace($encoded, "$markerStart",            strpos($encoded, "{"),1);
    //$encoded = substr_replace($encoded, "    ,"."$markerEnd" , strrpos($encoded, "}"),1 );
    $translations[$lang] = $encoded;
}

echo "Writing files:" . PHP_EOL;

foreach ($translations as $lang=>$encodedTranslates){
    $outFilePrefix = '-'.$lang;

    $outFileName = str_replace('__lang__', $outFilePrefix, $output_filename_csv);
    
    $fp = fopen($outFileName, 'w');
    fwrite($fp, 
            '(function(window){var dictionary = '.
            $encodedTranslates.';'.
            'window._t = function(key) { '.
                'if (!dictionary || !dictionary[key]){console.error(\'!Error : "\'+key+\'" not found in translations\');return key;}'.
                'return dictionary[key];'.
            '}})(window);'
    );
    fclose($fp);
    echo "File $outFileName      OK!" . PHP_EOL;
    
}

echo 'DONE', PHP_EOL;
